/****************************************************************
 * ItalkPipeConnection.h : Italk-Server connection class
 *
 * (c) 1997-1998 Yutaka Oiwa.
 *
 * You may distribute this file under the terms of license
 * agreement specified in the files README and LICENCE.
 *
 * $Id: ItalkPipeConnection.h,v 1.9 1998/10/17 18:10:26 yutaka Exp $
 ****************************************************************/

#ifndef _ITALK_PIPE_CONNECTION_H
#define _ITALK_PIPE_CONNECTION_H

#include "ItalkServer.h"
#include "LineBuffer.h"
#include <X11/Intrinsic.h>

class ItalkPipeConnection {
private:
  XtAppContext app;
  ItalkServer *ser;
  char *fullname;
  int port;
  int waittime;

  int num;
  char name[80], where[80], stat[80];
  int protocol;
  
  enum status_t { INIT, NAME_WAIT, CONN_WAIT, CONN, FAILED, HALT_1, HALT } status;
  bool update_allowed;
  bool in_italk_section, in_user_section;

  int soc;
  LineBuffer lbuf;
  XtInputId input_id;
  XtIntervalId interval_id;
  
  friend void cb_line_arrived(void *, char *, int);
  friend void cb_X_time_elapsed(void *, XtIntervalId*);
  friend void cb_X_connected(void *, int *, XtInputId*);
  friend void cb_X_data_arrived(void *, int *, XtInputId*);
  void getline(char *line, int len);
  void halt_process(char *line, int len);

  void set_state(enum status_t);
  void make_connection();

  void connect_failed(int);
  void connect_established();

public:
  ItalkServer *Server() {return ser;}
  ItalkPipeConnection(XtAppContext context, char *host, int waittime_,
		      ItalkServer_callback_t callback,
		      void *app_data);
  ~ItalkPipeConnection();
};

#endif
